<?php
/*
 * Include global Settings, Symbol List, and Functions
 */
require_once("symbols.php");
require_once("functions.php");
require_once("config.php");

/**
 * Read the Keys of the $maps Array
 */
$mapkeys = array_keys($maps);
/**
 * The name of the Map to be used
 */
$mapname = $mapkeys[0];

/*
 * Check if there is a map passed in the Query String
 * if so, use that name as the name of the Map to be used
 */
if (isset($_GET["map"])) {
    $mapname = $_GET["map"];
}

/**
 * Path and Filename of the script itself
 * ToDo: Check if still necessary
 */
$me = $_SERVER["PHP_SELF"];

/*
 * Call the Function GenerateMapImage
 * The return Value is useless here, but we need the Coordinates for the 
 * AREA-Tags of the Map
 */
$mapimg = GenerateMapImage($mapname);
?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
    <head>
	<meta http-equiv="Content-type" content="text/html;charset=UTF-8">
        <script type="text/javascript">
            var mapname = "<?= $mapname ?>";
        </script>
        <script type="text/javascript" src="scriptajax.js"></script>
        <link rel="stylesheet" type="text/css" href="style.css">
        <title>Heimautomation mit FHEM und AJAX</title>
    </head>
    <body>
        <div id="title">
            <h1>Heimautomation mit FHEM, PHP und AJAX</h1>
            Download der Projektdateien: <a href="homemini.tar">hier</a><br>
            Link zum <a target="_blank" href="http://heimserver.nendzig.net/wiki/index.php/HomeMini">Wiki</a><br>
            Link zur <a href="index.php">"Alten" Variante</a><br>
        </div>
        <hr>
        <div id="maplist">
            <?= ListMaps() ?>
        </div>

        <div id="ajax">
            <img src="getpic.php" alt="Map" usemap="#imgmap">
        </div>
        <div id="clickmap">
            <map id="map" name="imgmap">
                <?= GenerateMap($mapname) ?>
            </map>
        </div>
        <div id="cmdbox" class="cmdbox">COMMANDS</div>

        <div id="footer">
            <hr>
            Wer mir fuer meine Arbeit dermassen dankbar ist, dass er mir was Gutes tun will, ist hiermit herzlich dazu eingeladen :-) <br>
            <?php require($_SERVER["DOCUMENT_ROOT"] . "/snippets/donate.snip"); ?>
            <hr>
        </div>
    </body>
</html>

