<html>
    <head>
        <title>Heimautomatisierung</title>
        <meta http-equiv="refresh" content="10">
        <script type="text/javascript" src="script.js"></script>
        <link rel="stylesheet" type="text/css" href="style.css">
    </head>
    <body>
        <h1>Heimautomation mit FHEM und PHP</h1>
        Download der Projektdateien: <a href="homemini.tar">hier</a><br>
        Link zur <a href="ajax.php">"Neuen" Variante</a> (Ajax-basierend)<br>
        <hr>
        <?php
        require_once("config.php");
        require_once("symbols.php");
        require_once("functions.php");
        $fontfile = "fonts/arial.ttf";
        $fontsize = 10;

        $mapkeys = array_keys($maps);
        $mapname = $mapkeys[0];

        if (isset($_GET["map"])) {
            $mapname = $_GET["map"];
        }
        $bg_filename = $maps[$mapname]["img"];
        $me = $_SERVER["PHP_SELF"];
        ?>
        <div id="maplist">
            <?php foreach ($maps as $key => $map) { ?>
                <a href="<?= $me . '?map=' . $key ?>"><?= $map["comment"] ?></a><br>
            <?php } ?>
        </div>
        <?php
        $me = $me . "?map=" . $mapname;

        if (isset($_GET["ele"]))
            if (isset($_GET["val"])) {
                $ele = $_GET["ele"];
                $val = $_GET["val"];
                SetState($ele, $val);
                header("Location: " . $me);
            }


        $states = CreateStateList();
        $mapimg = ImageCreateFromPng($bg_filename);
        $bg_color = ImageColorAllocate($mapimg, 255, 255, 255);
        $fg_color = ImageColorAllocate($mapimg, 255, 0, 0);
        ImageFill($mapimg, 0, 0, $bg_color);

        foreach ($elements as $key => $element) {
            if ($element["map"] == $mapname) {
                $state[$key] = GetState($key);
                $typ = strtolower($element["typ"]);
                $imgpre = strtolower($element["imgpre"]);
                switch ($typ) {
                    case "sd":
                    case "la":
                        $element_img = ImageCreateFromPng("icons/" . $imgpre . "_" . (($state[$key] == "on") ? "on" : "off") . ".png");
                        break;
                    case "tf":
                        $tfarr = explode(" ", $state[$key]);
                        $text = $tfarr[0] . "°C\n" . $tfarr[1] . "%";
                        $element_img = CreateSymbolFromText($text);
                        break;
                    case "ht":
                        $text = $state[$key] . "%";
                        $element_img = CreateSymbolFromText($text);
                        break;
                    case "fht":
                        $text = "ist:\n" . $state[$key] . "°C";
                        $element_img = CreateSymbolFromText($text);
                        break;
                    default:
                        $tf_text = "???";
                        $element_img = CreateSymbolFromText($text);
                        break;
                }
                $l = $element["left"];
                $t = $element["top"];
                $w = imagesx($element_img);
                $h = imagesy($element_img);
                $elements[$key]["coords"] = $l . "," . $t . "," . ($l + $w) . "," . ($t + $h);
                ImageCopy($mapimg, $element_img, $l, $t, 0, 0, $w, $h);
            }
        }
        ob_start();
        ImagePng($mapimg);
        $imageb64 = base64_encode(ob_get_contents());
        $imagestring = chunk_split("$imageb64", 60, "\n");
        ob_end_clean();
        ImageDestroy($mapimg);
        ?>

        <img src="data:image/png;base64,<?= $imagestring ?>" alt="Map" usemap="#imgmap">
        <map name="imgmap">

            <?php
            foreach ($elements as $key => $element) {
            if ($element["map"] == $mapname) {
                $typ = strtolower($element["typ"]);
                ?>
                <area id="<?= $key ?>" shape="rect" coords="<?= $element['coords'] ?>" 
                      href="#<?= $key ?>" onClick="showcmdbox('1','<?= $me ?>','<?= $key ?>','<?= $typ ?>')" 
                      alt="<?= $key ?>">
                      <?php
                  }
		}
                  ?>
        </map>

        <div id="1" class="cmdbox" onclick="hidecmdbox()">COMMANDS</div>

        <div align="center">
            <hr>
            Wer mir für meine Arbeit dermassen dankbar ist, daß er mir was Gutes tun will, ist hiermit herzlich dazu eingeladen :-) <br>
            <?php require($_SERVER["DOCUMENT_ROOT"] . "/snippets/donate.snip"); ?>
            <hr>
        </div>
        <br>
    </body>
</html>
