document.onload = DoInit();
var timerevent = null;


/**
 * Ajax-Request-Function
 * Creates the XMLHttpRequest, Connects to Server and parses Result
 * 
 * @param ele If set, Element to pass to getpic.php
 * @param val If set, Value for Element to pass to getpic.php
 * @return bool Returns true on Success, false on Fail
 */
function DoIt(ele, val)
{
    /**
     * XMLHttpRequest Object
     */
    var req = null;
    
    // Create XMLHttpRequest-Object depending on supported Types
    try{
        // First try: Call Constructor of XMLHttpRequest
        req = new XMLHttpRequest();
    }catch(ms){
        // Second try: Create ActiveXObject Msxml2.XMLHTTP
        try{
            req = new ActiveXObject("Msxml2.XMLHTTP");
        }catch(noms){
            try{
                // Third try: Create ActiveXObject Microsoft.XMLHTTP
                req = new ActiveXObject("Microsoft.XMLHTTP");
            }catch(failed){
                // If no try was succesful, return NULL
                req = null;
            }
        }
    }
    // Check if XMLHttpRequest Object was successfully generated, else open Alert
    if(req == null) alert("Error creating request object!");
    // Get current Date and Time, used to create unique Requests (Anti-Cache-Feature :-))
    uhrzeit = new Date();
    // Generate Requeststring: We want to get the current Picture of mapname
    reqstring = "getpic.php?map=" + mapname;
    // If ele is set, pass it to getpic.php
    if(ele)reqstring += "&ele=" + ele;
    // If val is set, pass it to getpic.php
    if(val)reqstring += "&val=" + val;
    // Add Timestamp to Requeststring
    reqstring+= "&time=" + uhrzeit;

    // Open XMLHttpRequest
    req.open("GET", reqstring, true);

    // Definition of Eventhandler for ReadyState of Request
    req.onreadystatechange = function()
    {
        // Check for State "finished"
        switch(req.readyState){
            case 4: // finished = 4
                if(req.status != 200){ // Catch Request Failure
                    alert("Fehler:" + req.status); // Popup Alert Window on Fail
                }else{
                    // On Success, update the Image Tag of the Imagemap with the base64-coded Image getpic.php returned
                    document.getElementById("ajax").innerHTML = '<img src="data:image/png;base64,' + req.responseText + '" alt="Map" usemap="#imgmap">';
                }
                // Exit in Success
                return true;
                break;
            default:
                // Only return with TRUE on Success
                return false;
                break;
        }
    };
    // Prepare Request
    req.setRequestHeader("Content-Type","application/x-www-form-urlencoded");
    // Execute XMLHttpRequest
    req.send(null);
    // Close Commandbox after Execution
    HideCmdBox();
}    

function SetTimerEvent(onoff){
    window.clearInterval(timerevent);
    if(onoff == 1) {
        timerevent = window.setInterval("DoIt()", 10000);
    }
}

/**
 * Initialisation
 */
function DoInit(){
    // Set Timer, update the Image every 10s
    SetTimerEvent(1);
    cmdbox = null;
    // Set the Position of the CommandBox on every Click - obsolete 
    document.onclick = UpdateCmdBox;
    // Initial Update of Imagemap
    DoIt();
}

/**
 * Eventhandler for Click-Event: Update Commandbox-Position
 * 
 * @param e Window Event on Click
 */
function UpdateCmdBox(e){
    // Check if Commandbox is defined and visible
    if(cmdbox != null && cmdbox.style.display == 'block'){
        /**
         * x Position of Commandbox
         */
        var x = 0;
        /**
         * y Position of Commandbox
         */
        var y = 0;
        /**
         * Create Object which references to Parent of Commandbox
         */
        var obj = cmdbox.offsetParent;
        /*
         * Calculate Offset of Top Left Edge of Commandbox
         * Loop through all Parents and add the offsetLeft and offsetTop Values
         * As a result, we get the absolute Offset Left and Top of the Commandbox
         */
        while(obj){
            // Calculate Offset for Commandbox
            x -= obj.offsetLeft;
            y -= obj.offsetTop;
            // Set Parent to next Parent
            obj = obj.offsetParent;
        }
        // If no Event was created, set e to window.event
        if(!e) e = window.event;
        // If there is pageX/pageY defined, use this Value
        if(e.pageX || e.pageY){
            // Calculate relative Position of Mouseclick
            x += e.pageX;
            y += e.pageY;
        }else if (e.clientX || e.clientY){ // If clientX/clientY is defined, use that instead of pageX/Y
            // Calculate relative Position of Mouseclick
            x += e.clientX + document.body.scrollLeft + document.documentElement.scrollLeft;
            y += e.clientY + document.body.scrollTop + document.documentElement.scrollTop;
        }
        // Set top left Position of CommandBox
        cmdbox.style.left = (x) + "px";
        cmdbox.style.top   = (y) + "px";
    }
}

/**
 * Event Handler for Click into Slider-Box
 * 
 * @param ele Element to Set Value
 */
function SliderClick(ele){
    slider = document.getElementById("ht");
    // Setpoint is the Value that already is written in the Sliderbox
    val = slider.innerHTML;
    // Execute Command
    DoIt(ele, val);
}

/**
 * Event Handler for Mousemove over Slider-Box
 * 
 * @param e Mouse-Event
 * @param min Minimum Value of Slider (Left Position)
 * @param max Maximum Value of Slider (Right Position)
 * @param prz Precision of Value in count of Numbers after Comma
 */
function SliderMove(e, min, max, prz){
    // Create Event-Object, if not already defined
    e = e || window.event;
    slider = document.getElementById("ht");
    leftpos = 0;
    var obj = slider;
    // Check if offsetLeft is defined in SliderBox
    if(typeof obj.offsetLeft != 'undefined')
    {
        /*
         * Calculate left Position of Sliderbox
         * Loop through all Parents and summarize the offsetLeft-Values
        */
        while(obj)
        {
            leftpos += obj.offsetLeft;
            obj = obj.offsetParent;
        }
    }
    else // If SliderBox has a defined Value,
    {
        // Use that Value directly
        leftpos = obj.left;
    }
    // Get Mouse X Position: if pageX is defined,
    if (e.pageX){
        // use that as X Position
        x = e.pageX;
    }else if (e.clientX){
        // If clientY is Set, use that instead.
        x = e.clientX + document.body.scrollLeft + document.documentElement.scrollLeft;
    }
    // Calculate Setpoint with defined Precision; prz is the count of numbers after the comma
    // Include a little Space to the Left and to the right, so that we can reach the Min and Max Value
    val = Math.round((min+(max-min)*(x - leftpos - 5)/(slider.offsetWidth - 5))*Math.pow(10,prz))/Math.pow(10,prz);
    // If Value is below Minimum, set it to Minimum
    if (val < min)val = min;
    // If Value is over Maximum, set it to Maximum
    if (val > max)val=max;
    // Write Setpoint in SliderBox
    slider.innerHTML = val;
}

/**
 * Event Handler for MouseOut() from Slider-Box
 * Not used
 */
function SliderExit(){
}

/**
 * Create Content of Commandbox for Boolean Aktors
 * Creates two Buttons, one sets the State to "on" the other to "off"
 * 
 * @param ele type Element to set
 * @return string HTML String
 */
function GetContentOnOff(ele){
    retv = "<input type='button' onclick='DoIt(\"" + ele + "\", \"on\")' value='EIN' />";
    retv += "<br>\n";
    retv += "<input type='button' onclick='DoIt(\"" + ele + "\", \"off\")' value='AUS' />\n";
    return retv;
}

/**
 * Create Content of Commandbox for Sliders
 * Creates a Box with Border, where you can Slide with the Mouse to set the Value
 * 
 * @param ele type Element to set
 * @param min type Minimum Value
 * @param max type Maximum Value
 * @param prz type Precision of Value
 * @return string HTML String
 */
function GetContentSlide(ele, min, max, prz){
    retv = "<div id='ht' style='width:100pt;height:1em;border: 1px solid #000000;'\n \
             onmousemove='SliderMove(event," + min + "," + max + "," + prz + ")'\n \
             onmouseout='SliderExit()'\n \
             onclick=''></div><br>\n \
            <input type='button' onclick='SliderClick(\"" + ele + "\")' value='OK' />\n";
    return retv;
}

function UpdateContentPlot(ele){
    content = GetContentPlot(ele);
    // Add default Exit Button
    content = "<div id='cmdboxexit' style='text-align:left;width=100%;'>\n \
                 <input type='button' style='width:auto;height:auto;' onclick='HideCmdBox()' value='X'/><br>\n \
               </div>\nPlot:<br>\n" + content;

    // Update Content of CommandBox
    cmdbox.innerHTML = content;
}

function GetContentPID(ele, min, max, prz){
   retv = GetContentSlide(ele, min, max, prz);
   retv += "<br>\n<input type='button' onclick='UpdateContentPlot(\"" + ele + "\")' value='Plot' />\n";
   return retv;
}

/**
 * Create Content of CommandBox for Plots
 * Displays the current Plot Data of ele
 * 
 * @param ele type Element to Display
 * @return string HTML String
 */
function GetContentPlot(ele){
    // Uncomment the following Line, if PNG Files are to be displayed
    //retv = "<img src='plots/" + ele + ".png' alt='Plot von " + ele + "'>\n";
    // Uncomment the following Line, if SVG Files are to be displayed
    retv = "<embed src='plots/" + ele + ".svg' width='800' height='250' name='" + ele + "'/>\n"
    return retv;
}

/**
 * Show CommandBox
 * 
 * @param id type ID of CommandBox
 * @param link type osolete.
 * @param ele type Element to Show/Set
 * @param typ type Type of Element
 */
function ShowCmdBox(e, id, link, ele, typ){
    // SD and LA are boolean Actors
    if((typ == "sd")|(typ == "la")){
        content = GetContentOnOff(ele);
    }else if(typ == "ht"){ // HT can be set from 0% to 100% in 1% Steps
        content = GetContentSlide(ele, 0, 100, 0);
    }else if(typ == "fht"){ // FHT can be set from 16 to 27°C in 1°C Steps
        content = "Soll:<br>" + GetContentSlide(ele, 16, 27, 1);
    }else if(typ == "pid"){ // PID can be set from 16 to 30°C in 1°C Steps
        content = "Soll:<br>" + GetContentPID(ele, 16, 30, 1);
    }else if(typ == "tf"){ // TF can only Display a Plot
        content = GetContentPlot(ele);
    }else{
        return;
    }
    // Add default Exit Button
    content = "<div id='cmdboxexit' style='text-align:left;width=100%;'>\n \
                 <input type='button' style='width:auto;height:auto;' onclick='HideCmdBox()' value='X'/><br>\n \
               </div>\n" + content;

    cmdbox = document.getElementById(id);
    // Update Content of CommandBox
    cmdbox.innerHTML = content;
    // Set CommandBox visible
    cmdbox.style.display = "block"
    // Move Command Box to Position of Mouseclick
    UpdateCmdBox(e);
    SetTimerEvent(0);
}

/**
 * Event Handler for Mouslick inside CommandBox
 * Switch off COmmandbox in that Case
 */
function HideCmdBox(){
    // Set Display Style to none makes CommandBox invisible
    cmdbox.style.display = "none";
    SetTimerEvent(1);
}


